<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_101) on Fri Oct 21 15:02:57 EDT 2016 -->
<title>QuartoLogic</title>
<meta name="date" content="2016-10-21">
<link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style">
<script type="text/javascript" src="../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="QuartoLogic";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../quarto/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../quarto/Player.html" title="class in quarto"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../quarto/Shape.html" title="enum in quarto"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?quarto/QuartoLogic.html" target="_top">Frames</a></li>
<li><a href="QuartoLogic.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">quarto</div>
<h2 title="Class QuartoLogic" class="title">Class QuartoLogic</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>quarto.QuartoLogic</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public final class <span class="typeNameLabel">QuartoLogic</span>
extends java.lang.Object</pre>
<div class="block">The Quarto class contains the logic and implementation of
 the Quarto game. Creates the Quarto game which includes a board,
 16 pieces, two players, and player scores. Has the ability to 
 determine if the game has been won, to place a piece on the board,
 instantiate a new game and clear the board, advance the player
 turn, and to undo moves.</div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>10/03/16</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Kyle Hekhuis</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#AMOUNT_OF_UNDOS">AMOUNT_OF_UNDOS</a></span></code>
<div class="block">How many game states can be undone.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.ArrayList&lt;<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#availablePieces">availablePieces</a></span></code>
<div class="block">ArrayList of Piece containing all the available pieces.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../quarto/Board.html" title="class in quarto">Board</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#board">board</a></span></code>
<div class="block">Quarto game board.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#BOARD_COLUMNS">BOARD_COLUMNS</a></span></code>
<div class="block">Column size of Quarto game board.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#BOARD_DIAGONALS">BOARD_DIAGONALS</a></span></code>
<div class="block">Number of diagonals on Quarto game board.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#BOARD_ROWS">BOARD_ROWS</a></span></code>
<div class="block">Row size of Quarto game board.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int[][]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#counterColumns">counterColumns</a></span></code>
<div class="block">Counters for each column and property.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int[][]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#counterDiagonals">counterDiagonals</a></span></code>
<div class="block">Counters for each diagonal and property.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int[][]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#counterRows">counterRows</a></span></code>
<div class="block">Counters for each row and property.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../quarto/Player.html" title="class in quarto">Player</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#currentPlayer">currentPlayer</a></span></code>
<div class="block">Current player whose turn it is.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#DIAGONAL_CHECK">DIAGONAL_CHECK</a></span></code>
<div class="block">Used to check if diagonal from bottom left to top right.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#isDraw">isDraw</a></span></code>
<div class="block">Keeps track of whether or not there is a draw in the game.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#isWinner">isWinner</a></span></code>
<div class="block">Keeps track of whether or not there is a winner in the game.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#NUM_OF_ATTRIBUTES">NUM_OF_ATTRIBUTES</a></span></code>
<div class="block">NUM_OF_ATTRIBUTES is amount of counters for all the attributes for Piece.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../quarto/Player.html" title="class in quarto">Player</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#player1">player1</a></span></code>
<div class="block">Player entity which can either be a real person or AI.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../quarto/Player.html" title="class in quarto">Player</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#player2">player2</a></span></code>
<div class="block">Player entity which can either be a real person or AI.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#score">score</a></span></code>
<div class="block">Array containing the current score for each player.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../quarto/Piece.html" title="class in quarto">Piece</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#selectedPiece">selectedPiece</a></span></code>
<div class="block">The currently selected Piece.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../quarto/MaxSizeStack.html" title="class in quarto">MaxSizeStack</a>&lt;<a href="../quarto/GameState.html" title="class in quarto">GameState</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#undoStack">undoStack</a></span></code>
<div class="block">Stack containing previous game states to
 revert back to for undo function.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#QuartoLogic-quarto.Player-quarto.Player-">QuartoLogic</a></span>(<a href="../quarto/Player.html" title="class in quarto">Player</a>&nbsp;pPlayer1,
           <a href="../quarto/Player.html" title="class in quarto">Player</a>&nbsp;pPlayer2)</code>
<div class="block">Instantiates a game of Quarto containing a 4x4 board,
 16 pieces, 2 players, and player scores.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#clearBoard--">clearBoard</a></span>()</code>
<div class="block">Clears all pieces from the board.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>private java.util.ArrayList&lt;<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#cloneAvailablePieces--">cloneAvailablePieces</a></span>()</code>
<div class="block">Clones the current availablePieces.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private int[][]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#cloneCounter-int:A:A-">cloneCounter</a></span>(int[][]&nbsp;counter)</code>
<div class="block">Clones the passed counter.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>private int[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#cloneScore--">cloneScore</a></span>()</code>
<div class="block">Clones the current score.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>private <a href="../quarto/GameState.html" title="class in quarto">GameState</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#createGameState--">createGameState</a></span>()</code>
<div class="block">Gets the current game state and returns it.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#dec-int:A:A-int-int-">dec</a></span>(int[][]&nbsp;counters,
   int&nbsp;row,
   int&nbsp;property)</code>
<div class="block">Decrements the value of a single counter, and changes the value
 of isWinner if a winner occurs.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="../quarto/Board.html" title="class in quarto">Board</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#getBoard--">getBoard</a></span>()</code>
<div class="block">Returns the current state of the game board.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="../quarto/Player.html" title="class in quarto">Player</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#getCurrentPlayer--">getCurrentPlayer</a></span>()</code>
<div class="block">Retrieves the player who's turn it is currently.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>java.util.ArrayList&lt;<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#getPieces--">getPieces</a></span>()</code>
<div class="block">Retrieves the pieces that have not been used yet.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>int[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#getScore--">getScore</a></span>()</code>
<div class="block">Returns an array containing each player's score.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code><a href="../quarto/Piece.html" title="class in quarto">Piece</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#getSelected--">getSelected</a></span>()</code>
<div class="block">Retrieves the currently selected piece.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#inc-int:A:A-int-int-">inc</a></span>(int[][]&nbsp;counters,
   int&nbsp;row,
   int&nbsp;property)</code>
<div class="block">Increments the value of a single counter, and changes the value
 of isWinner if a winner occurs.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#instantiateCounters--">instantiateCounters</a></span>()</code>
<div class="block">Instantiates all the counters and sets each
 entry in the counters to 0.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#instantiatePieces--">instantiatePieces</a></span>()</code>
<div class="block">Fills ArrayList<Piece> availablePieces with all 16 Quarto pieces.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#instantiateScore--">instantiateScore</a></span>()</code>
<div class="block">Instantiates the player score to 0 for both players.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#isDraw--">isDraw</a></span>()</code>
<div class="block">Checks to see if game has ended in a draw.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#isWinner--">isWinner</a></span>()</code>
<div class="block">Checks to see if the game has been won.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#nextRound--">nextRound</a></span>()</code>
<div class="block">Starts a new round, keeping settings.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#nextTurn--">nextTurn</a></span>()</code>
<div class="block">Advances the turn to the next player.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#placePiece-int-int-">placePiece</a></span>(int&nbsp;row,
          int&nbsp;col)</code>
<div class="block">Places selected piece onto the empty board cell, takes the piece out of
 available pieces, and updates the counters.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#placePiece-quarto.Piece-int-int-">placePiece</a></span>(<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&nbsp;piece,
          int&nbsp;row,
          int&nbsp;column)</code>
<div class="block">Places a piece on a certain spot on the board.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#selectPiece-int-">selectPiece</a></span>(int&nbsp;index)</code>
<div class="block">Selects given piece, replace selected piece with a null value in the 
 availablePieces ArrayList, because it can no longer be played.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#setDraw--">setDraw</a></span>()</code>
<div class="block">Checks if the board is full.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#setScore--">setScore</a></span>()</code>
<div class="block">Sets the players' score based off who won the game.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#undoMove--">undoMove</a></span>()</code>
<div class="block">Undoes the last move.</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../quarto/QuartoLogic.html#updateCounters-int-int-">updateCounters</a></span>(int&nbsp;row,
              int&nbsp;col)</code>
<div class="block">Updates all the relevant counters to currently played piece, and 
 changes the value of isWinner if the piece played is the winning
 piece.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="BOARD_ROWS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BOARD_ROWS</h4>
<pre>private static final&nbsp;int BOARD_ROWS</pre>
<div class="block">Row size of Quarto game board.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#quarto.QuartoLogic.BOARD_ROWS">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="BOARD_COLUMNS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BOARD_COLUMNS</h4>
<pre>private static final&nbsp;int BOARD_COLUMNS</pre>
<div class="block">Column size of Quarto game board.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#quarto.QuartoLogic.BOARD_COLUMNS">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="BOARD_DIAGONALS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BOARD_DIAGONALS</h4>
<pre>private static final&nbsp;int BOARD_DIAGONALS</pre>
<div class="block">Number of diagonals on Quarto game board.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#quarto.QuartoLogic.BOARD_DIAGONALS">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="DIAGONAL_CHECK">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DIAGONAL_CHECK</h4>
<pre>private static final&nbsp;int DIAGONAL_CHECK</pre>
<div class="block">Used to check if diagonal from bottom left to top right.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#quarto.QuartoLogic.DIAGONAL_CHECK">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="NUM_OF_ATTRIBUTES">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>NUM_OF_ATTRIBUTES</h4>
<pre>private static final&nbsp;int NUM_OF_ATTRIBUTES</pre>
<div class="block">NUM_OF_ATTRIBUTES is amount of counters for all the attributes for Piece.
 1. Hollow: Hollow / Solid
 2. Color: Blue / Black
 3. Shape: Round / Square
 4. Size: Big / Small.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#quarto.QuartoLogic.NUM_OF_ATTRIBUTES">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="AMOUNT_OF_UNDOS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>AMOUNT_OF_UNDOS</h4>
<pre>private static final&nbsp;int AMOUNT_OF_UNDOS</pre>
<div class="block">How many game states can be undone.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../constant-values.html#quarto.QuartoLogic.AMOUNT_OF_UNDOS">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="board">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>board</h4>
<pre>private&nbsp;<a href="../quarto/Board.html" title="class in quarto">Board</a> board</pre>
<div class="block">Quarto game board.</div>
</li>
</ul>
<a name="player1">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>player1</h4>
<pre>private&nbsp;<a href="../quarto/Player.html" title="class in quarto">Player</a> player1</pre>
<div class="block">Player entity which can either be a real person or AI.</div>
</li>
</ul>
<a name="player2">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>player2</h4>
<pre>private&nbsp;<a href="../quarto/Player.html" title="class in quarto">Player</a> player2</pre>
<div class="block">Player entity which can either be a real person or AI.</div>
</li>
</ul>
<a name="currentPlayer">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>currentPlayer</h4>
<pre>private&nbsp;<a href="../quarto/Player.html" title="class in quarto">Player</a> currentPlayer</pre>
<div class="block">Current player whose turn it is.</div>
</li>
</ul>
<a name="counterRows">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>counterRows</h4>
<pre>private&nbsp;int[][] counterRows</pre>
<div class="block">Counters for each row and property. 
 row| hollow | color | shape | size
  0 |    0       0       0      0
  1 |    0       0       0      0  
  2 |    0       0       0      0
  3 |    0       0       0      0</div>
</li>
</ul>
<a name="counterColumns">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>counterColumns</h4>
<pre>private&nbsp;int[][] counterColumns</pre>
<div class="block">Counters for each column and property. 
 row| hollow | color | shape | size
  0 |    0       0       0      0
  1 |    0       0       0      0  
  2 |    0       0       0      0
  3 |    0       0       0      0</div>
</li>
</ul>
<a name="counterDiagonals">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>counterDiagonals</h4>
<pre>private&nbsp;int[][] counterDiagonals</pre>
<div class="block">Counters for each diagonal and property. 
 diagonal | hollow | color | shape | size
     0    |    0       0       0      0
     1    |    0       0       0      0</div>
</li>
</ul>
<a name="availablePieces">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>availablePieces</h4>
<pre>private&nbsp;java.util.ArrayList&lt;<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&gt; availablePieces</pre>
<div class="block">ArrayList of Piece containing all the available pieces.</div>
</li>
</ul>
<a name="selectedPiece">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selectedPiece</h4>
<pre>private&nbsp;<a href="../quarto/Piece.html" title="class in quarto">Piece</a> selectedPiece</pre>
<div class="block">The currently selected Piece.</div>
</li>
</ul>
<a name="isWinner">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isWinner</h4>
<pre>private&nbsp;boolean isWinner</pre>
<div class="block">Keeps track of whether or not there is a winner in the game.</div>
</li>
</ul>
<a name="isDraw">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isDraw</h4>
<pre>private&nbsp;boolean isDraw</pre>
<div class="block">Keeps track of whether or not there is a draw in the game.</div>
</li>
</ul>
<a name="score">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>score</h4>
<pre>private&nbsp;int[] score</pre>
<div class="block">Array containing the current score for each player. 
 Index 1 = Player 1; Index 2 = Player 2</div>
</li>
</ul>
<a name="undoStack">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>undoStack</h4>
<pre>private&nbsp;<a href="../quarto/MaxSizeStack.html" title="class in quarto">MaxSizeStack</a>&lt;<a href="../quarto/GameState.html" title="class in quarto">GameState</a>&gt; undoStack</pre>
<div class="block">Stack containing previous game states to
 revert back to for undo function.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="QuartoLogic-quarto.Player-quarto.Player-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>QuartoLogic</h4>
<pre>public&nbsp;QuartoLogic(<a href="../quarto/Player.html" title="class in quarto">Player</a>&nbsp;pPlayer1,
                   <a href="../quarto/Player.html" title="class in quarto">Player</a>&nbsp;pPlayer2)</pre>
<div class="block">Instantiates a game of Quarto containing a 4x4 board,
 16 pieces, 2 players, and player scores.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pPlayer1</code> - player 1 in the game</dd>
<dd><code>pPlayer2</code> - player 2 in the game</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="instantiatePieces--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>instantiatePieces</h4>
<pre>private&nbsp;void&nbsp;instantiatePieces()</pre>
<div class="block">Fills ArrayList<Piece> availablePieces with all 16 Quarto pieces.</div>
</li>
</ul>
<a name="instantiateCounters--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>instantiateCounters</h4>
<pre>private&nbsp;void&nbsp;instantiateCounters()</pre>
<div class="block">Instantiates all the counters and sets each
 entry in the counters to 0.</div>
</li>
</ul>
<a name="instantiateScore--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>instantiateScore</h4>
<pre>private&nbsp;void&nbsp;instantiateScore()</pre>
<div class="block">Instantiates the player score to 0 for both players.</div>
</li>
</ul>
<a name="inc-int:A:A-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>inc</h4>
<pre>private&nbsp;void&nbsp;inc(int[][]&nbsp;counters,
                 int&nbsp;row,
                 int&nbsp;property)</pre>
<div class="block">Increments the value of a single counter, and changes the value
 of isWinner if a winner occurs.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>counters</code> - is the single counter to be incremented</dd>
<dd><code>row</code> - is the row to increment</dd>
<dd><code>property</code> - is the property of the piece</dd>
</dl>
</li>
</ul>
<a name="dec-int:A:A-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>dec</h4>
<pre>private&nbsp;void&nbsp;dec(int[][]&nbsp;counters,
                 int&nbsp;row,
                 int&nbsp;property)</pre>
<div class="block">Decrements the value of a single counter, and changes the value
 of isWinner if a winner occurs.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>counters</code> - is the single counter to be decremented</dd>
<dd><code>row</code> - is the row to increment</dd>
<dd><code>property</code> - is the property of the piece</dd>
</dl>
</li>
</ul>
<a name="updateCounters-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updateCounters</h4>
<pre>private&nbsp;void&nbsp;updateCounters(int&nbsp;row,
                            int&nbsp;col)</pre>
<div class="block">Updates all the relevant counters to currently played piece, and 
 changes the value of isWinner if the piece played is the winning
 piece.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>row</code> - is the row of the cell onto which the Piece was played</dd>
<dd><code>col</code> - is the col of the cell onto which the Piece was played</dd>
</dl>
</li>
</ul>
<a name="placePiece-quarto.Piece-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>placePiece</h4>
<pre>public&nbsp;boolean&nbsp;placePiece(<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&nbsp;piece,
                          int&nbsp;row,
                          int&nbsp;column)</pre>
<div class="block">Places a piece on a certain spot on the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>piece</code> - piece to be placed on board</dd>
<dd><code>row</code> - row to place the piece into</dd>
<dd><code>column</code> - column to place the piece into</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if piece was placed successfully</dd>
</dl>
</li>
</ul>
<a name="placePiece-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>placePiece</h4>
<pre>public&nbsp;boolean&nbsp;placePiece(int&nbsp;row,
                          int&nbsp;col)</pre>
<div class="block">Places selected piece onto the empty board cell, takes the piece out of
 available pieces, and updates the counters.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>row</code> - is the row of the cell onto which the Piece was played</dd>
<dd><code>col</code> - is the column of the cell onto which the Piece was played</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if placing the piece succeeded, false otherwise</dd>
</dl>
</li>
</ul>
<a name="selectPiece-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selectPiece</h4>
<pre>public&nbsp;void&nbsp;selectPiece(int&nbsp;index)</pre>
<div class="block">Selects given piece, replace selected piece with a null value in the 
 availablePieces ArrayList, because it can no longer be played.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>index</code> - is the index of the selected Piece in the availablePieces
 ArrayList</dd>
</dl>
</li>
</ul>
<a name="clearBoard--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearBoard</h4>
<pre>public&nbsp;void&nbsp;clearBoard()</pre>
<div class="block">Clears all pieces from the board.</div>
</li>
</ul>
<a name="getBoard--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBoard</h4>
<pre>public&nbsp;<a href="../quarto/Board.html" title="class in quarto">Board</a>&nbsp;getBoard()</pre>
<div class="block">Returns the current state of the game board.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the Board object used by the current game</dd>
</dl>
</li>
</ul>
<a name="undoMove--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>undoMove</h4>
<pre>public&nbsp;void&nbsp;undoMove()</pre>
<div class="block">Undoes the last move.</div>
</li>
</ul>
<a name="createGameState--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createGameState</h4>
<pre>private&nbsp;<a href="../quarto/GameState.html" title="class in quarto">GameState</a>&nbsp;createGameState()</pre>
<div class="block">Gets the current game state and returns it.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>GameState object with current game state</dd>
</dl>
</li>
</ul>
<a name="cloneAvailablePieces--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cloneAvailablePieces</h4>
<pre>private&nbsp;java.util.ArrayList&lt;<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&gt;&nbsp;cloneAvailablePieces()</pre>
<div class="block">Clones the current availablePieces.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>clone of availablePieces</dd>
</dl>
</li>
</ul>
<a name="cloneCounter-int:A:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cloneCounter</h4>
<pre>private&nbsp;int[][]&nbsp;cloneCounter(int[][]&nbsp;counter)</pre>
<div class="block">Clones the passed counter.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>counter</code> - counter to clone</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>cloned copy of passed counter</dd>
</dl>
</li>
</ul>
<a name="cloneScore--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cloneScore</h4>
<pre>private&nbsp;int[]&nbsp;cloneScore()</pre>
<div class="block">Clones the current score.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>clone of current score</dd>
</dl>
</li>
</ul>
<a name="isWinner--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isWinner</h4>
<pre>public&nbsp;boolean&nbsp;isWinner()</pre>
<div class="block">Checks to see if the game has been won.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if winning conditions have been met, false otherwise.</dd>
</dl>
</li>
</ul>
<a name="isDraw--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isDraw</h4>
<pre>public&nbsp;boolean&nbsp;isDraw()</pre>
<div class="block">Checks to see if game has ended in a draw.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if game has ended in a draw, false otherwise.</dd>
</dl>
</li>
</ul>
<a name="nextTurn--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nextTurn</h4>
<pre>public&nbsp;void&nbsp;nextTurn()</pre>
<div class="block">Advances the turn to the next player.</div>
</li>
</ul>
<a name="setDraw--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setDraw</h4>
<pre>private&nbsp;void&nbsp;setDraw()</pre>
<div class="block">Checks if the board is full. If it is, the game
 is a draw and sets isDraw to true.</div>
</li>
</ul>
<a name="nextRound--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nextRound</h4>
<pre>public&nbsp;void&nbsp;nextRound()</pre>
<div class="block">Starts a new round, keeping settings.</div>
</li>
</ul>
<a name="setScore--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setScore</h4>
<pre>private&nbsp;void&nbsp;setScore()</pre>
<div class="block">Sets the players' score based off who won the game.</div>
</li>
</ul>
<a name="getScore--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getScore</h4>
<pre>public&nbsp;int[]&nbsp;getScore()</pre>
<div class="block">Returns an array containing each player's score.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>int,  containing each player's score.</dd>
</dl>
</li>
</ul>
<a name="getPieces--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPieces</h4>
<pre>public&nbsp;java.util.ArrayList&lt;<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&gt;&nbsp;getPieces()</pre>
<div class="block">Retrieves the pieces that have not been used yet.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an ArrayList<Piece> of all the pieces that
 have not yet been used by the game.</dd>
</dl>
</li>
</ul>
<a name="getCurrentPlayer--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCurrentPlayer</h4>
<pre>public&nbsp;<a href="../quarto/Player.html" title="class in quarto">Player</a>&nbsp;getCurrentPlayer()</pre>
<div class="block">Retrieves the player who's turn it is currently.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the Player whose turn it is</dd>
</dl>
</li>
</ul>
<a name="getSelected--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getSelected</h4>
<pre>public&nbsp;<a href="../quarto/Piece.html" title="class in quarto">Piece</a>&nbsp;getSelected()</pre>
<div class="block">Retrieves the currently selected piece.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>null if no piece is currently selected, or
 the currently selected Piece object</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../quarto/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../quarto/Player.html" title="class in quarto"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../quarto/Shape.html" title="enum in quarto"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?quarto/QuartoLogic.html" target="_top">Frames</a></li>
<li><a href="QuartoLogic.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
